/****************************************************************************
 ***             Beispielprogramm fr PC-Steckkarte DA 1326               ***
 ****************************************************************************
 *** Programmname      : 1326C.C                                          ***
 *** Programmiersprache: Turbo C++ Version 3.0                            ***
 ***                                                                      ***
 *** erstellt von       Datum                                             ***
 *** Ralf Mller        24.06.97                                          ***
 ****************************************************************************
 *** ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen             ***
 *** Tel.: 07462/7381                                                     ***
 *** Fax : 07462/7554                                                     ***
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

// Funktionsdelklarationen
void write_board(int,int);			// Ausgabe eines Wertes auf die DA 1326
void out_wert(int);					// Eingabe eines neuen Wertes
void in_eingaenge(void);			// digitale Eingnge einlesen und ausgeben
void box(int,int,int,int);			// Rahmen zeichnen

// globale Variablendeklarationen
int konfig[8]={0,0,0,0,0,0,0,0,};	// Ausgabewerte der Kanle 1-8
int address=0x100;					// Basisadresse der DA 1326


// Hauptprogramm
void main(void)
{
	// lokale Variablendeklarationen
	int i;      					// Laufvariable
	char key;
	char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen ";
	char text2[]="      Tel. 07462/7381               Fax 07462/7554        ";

	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	_setcursortype(_NOCURSOR);
	textattr(0x7F);
	box(11,2,70,5);
	gotoxy(12,3);
	textattr(0x70);
	cprintf(text1);
	gotoxy(12,4);
	cprintf(text2);
	// Fenster fr digitale Eingnge
	box(11,9,26,11);
	box(11,13,26,15);
	box(11,17,26,19);
	box(11,21,26,23);
	// Fenster fr Ausgnge 1-8
	box(30,11,52,21);
	textattr(0x17);
	gotoxy(31,20);
	cprintf("                     ");
	textattr(0x13);
	gotoxy(36,20);
	cprintf("ESC = Ende");
	textattr(0x70);
	// Text fr Fenster der digitalen Eingnge ausgeben
	for(i=0;i<=3;i++)
	{
		gotoxy(12,10+i*4);
		cprintf(" Eingang %1d: ", i+1);
	}
	// Text fr Fenster der Ausgnge 1-8 ausgeben
	for(i=0;i<=7;i++)
	{
		gotoxy(31,12+i);
		cprintf(" F%1d = Kanal %1d: ",i+1,i+1);
		gotoxy(46,12+i);
		cprintf("%4d", konfig[i]);
	}

	do
	{
		i=kbhit();
		if (i!=0)
		{
			key=getch();
			if (key==0)
				key=getch();
			switch (key)
			{
				// Taste F1 bettigt
				case 59:
						// neuer Wert einholen und auf Kanal 1 ausgeben
						out_wert(0);
						break;
				// Taste F2 bettigt
				case 60:
						// neuer Wert einholen und auf Kanal 2 ausgeben
						out_wert(1);
						break;
				// Taste F3 bettigt
				case 61:
						// neuer Wert einholen und auf Kanal 3 ausgeben
						out_wert(2);
						break;
				// Taste F4 bettigt
				case 62:
						// neuer Wert einolen und auf Kanal 4 ausgeben
						out_wert(3);
						break;
				// Taste F5 bettigt
				case 63:
						// neuer Wert einholen und auf Kanal 5 ausgeben
						out_wert(4);
						break;
				// Taste F6 bettigt
				case 64:
						// neuer Wert einholen und auf Kanal 6 ausgeben
						out_wert(5);
						break;
				// Taste F7 bettigt
				case 65:
						// neuer Wert einholen und auf Kanal 7 ausgeben
						out_wert(6);
						break;
				// Taste F8 bettigt
				case 66:
						// neuer Wert einholen und auf Kanal 8 ausgeben
						out_wert(7);
						break;
			}
		}
		// einlesen der digitalen Eingnge und Ausgabe
		in_eingaenge();
	// Abbruch = ESC-Taste
	}while(key!=27);
	// Ausgangskanle auf Minimum des Bereiches setzen
	for(i=0;i<=7;i++)
	{
		write_board(0x00,i);
	}
	// Bildschirm lschen
	textattr(0x7);
	clrscr();
	_setcursortype(_NORMALCURSOR);
}

// Funktion zur Ausgabe eines Wertes an die DA 1326
void write_board(int wert, int Kanal)
{
	// Abfrage des Statusbit, ob vorherige DA-Wandlung noch aktiv ist
	do
	{
	}while((inportb(address) & 0x08)==0);
	// neue Messwertausgabe starten
	outportb(address,(wert & 0xFF));      				  	// untere 8 Bit
	outportb(address+1,((wert >> 8) + (Kanal << 4)));  	  	// untere 4 Bit

}

// Funktion zum Einlesen eines neuen Wertes und Ausgabe an die DA 1326
void out_wert(int Kanal)
{
	int error=0;
	int	i;
	char key_input[11];
	char *p;
	int wert;

	// Edit-Fenster ausgeben
	box(56,12+Kanal-2,71,12+Kanal+1);
	textattr(0x70);
	gotoxy(59,12+Kanal-1);
	cprintf("von 0-4095");
	do
	{
		// Fehlerflag zurcksetzen
		error=0;
		// Textausgabe fr Edit-Fenster
		textattr(0x70);
		gotoxy(57,12+Kanal);
		cprintf("Wert: ");
		gotoxy(63,12+Kanal);
		// Cursor fr Eingabe einschalten
		_setcursortype(_NORMALCURSOR);
		// maximal 8 Zeichen eingeben (mit CR+LF)
		key_input[0]=5;
		// eingabe einholen
		p=cgets(key_input);
		// Cursor abschalten
		_setcursortype(_NOCURSOR);
		// Fehlererkennung fr nur Return-Eingabe
		if(key_input[1]=='\0')
			error=1;
		// Fehlererkennung fr falsche Zeichen
		if(error!=1)
		{
			for(i=1;i<=key_input[1];i++)
			{
				switch(key_input[i+1])
				{
					// Zeichen, die erlaubt sind
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
							break;
					default:
							error=1;
							break;
				}
			}
		}
		// Eingabewert umwandeln in integer
		wert=atoi(p);
		if(error==0)
			if((wert<0) || (wert>4095))
				error=1;
		// Ausgabe der Fehlermeldung im Edit-Fenster
		if(error==1)
		{
			gotoxy(57,12+Kanal);
			cprintf("falscher Wert");
			delay(500);
			gotoxy(57,12+Kanal);
			cprintf("             ");
		}
	// Eingabe wiederholen bis Fehlerflag = 0
	}while(error==1);
	write_board(wert,Kanal);
	konfig[Kanal]=wert;
	gotoxy(46,12+Kanal);
	cprintf("%4d", konfig[Kanal]);
	// Edit-Fenster lschen
	window(56,10,80,25);
	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	window(1,1,80,25);
}

void in_eingaenge(void)
{
	int input=0;
	int	i;
	int eingaenge[4]={0,0,0,0};

	input=inportb(address);
	input=input >> 4;
	eingaenge[0]=(input & 0x01);		// digitaler Eingang 1
	input=input >> 1;
	eingaenge[1]=(input & 0x01);		// digitaler Eingang 2
	input=input >> 1;
	eingaenge[2]=(input & 0x01);		// digitaler Eingang 3
	input=input >> 1;
	eingaenge[3]=(input & 0x01);		// digitaler Eingang 4
	textattr(0x70);
	for(i=0;i<=3;i++)
	{
		gotoxy(24,10+i*4);
		cprintf("%1d", eingaenge[i]);
	}
}

void box(int x1, int y1, int x2, int y2)
{
  int i,
	  n;

  textattr(0x7F);
  gotoxy(x1,y1);
  cprintf("");
  gotoxy(x2,y1);
  cprintf("");
  gotoxy(x1,y2);
  cprintf("");
  gotoxy(x2,y2);
  cprintf("");
  for (i=x1+1;i<=x2-1;i++)
  {
	gotoxy(i,y1);
	cprintf("");
	gotoxy(i,y2);
	cprintf("");
  }
  for (i=y1+1;i<=y2-1;i++)
  {
	gotoxy(x1,i);
	cprintf("");
	gotoxy(x2,i);
	cprintf("");
  }
  for (i=y1+1;i<=y2-1;i++)
  {
	for (n=x1+1;n<=x2-1;n++)
	{
	  gotoxy(n,i);
	  cprintf(" ");
	}
  }
  textattr(0x10);
  for (i=x1+2;i<=x2+1;i++)
  {
	gotoxy(i,y2+1);
	cprintf("");
  }
  for (i=y1+1;i<=y2+1;i++)
  {
	gotoxy(x2+1,i);
	cprintf("");
  }
}
