/****************************************************************************
 ***               Testprogramm fr PC-Steckkarte DA 1256                 ***
 ****************************************************************************
 *** Programmname      : 1326TEST.C                                       ***
 *** Programmiersprache: Turbo C++ Version 3.0                            ***
 ***                                                                      ***
 *** erstellt von       Datum                                             ***
 *** Ralf Mller        24.06.97                                          ***
 ****************************************************************************
 *** ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen             ***
 *** Tel.: 07462/7381                                                     ***
 *** Fax : 07462/7554                                                     ***
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

// Funktionsdeklarationen
// Funktionen fr DA 1326
void write_board(int voltage, int channel);		// Ausgabe eines Wertes an DA 1326
void digitale_Eingaenge(void);					// Einlesen der digitalen Eingnge
												// der DA 1326

// Funktionen fr Mendarstellungen
void haupt_menue(void);				// Hauptmen erstellen
void haupt_menue_bar(int);			// Cursorposition im Hauptmen hervorheben
void ausgabe_menue(void);			// Ausgabemen erstellen
void ausgabe_menue_bar(int);		// Cursorposition im Ausgabemen hervorheben
int  konfig_menue(int);				// Konfigurationsmen erstellen und neue
									// Konfiguration zurckgeben
float edit_fenster(int);			// Edit-Fenster fr Werteingabe erstellen
									// und neuen Wert zurckgeben

// Funktionen fr Rahmenerstellung
void box(int, int, int, int);
void box1(int,int,int,int);

// globale Variablendeklarationen
int address=0x100;					// Basisadresse der DA 1326
int key,							// Variable fr Tastenbettigung
	i;								// Laufvariable
int konfig[8]={3,3,3,3,3,3,3,3};	// Konfiguration der Ausgnge =  10 V
char screen_buffer[1500];
char screen_buffer1[1500];
float ausgabe_wert[8];				// Ausgabewerte der Ausgnge

/****************************************************************************
 ***                    Hauptprogramm                                     ***
 ****************************************************************************/
void main(void)
{
	// lokale Variablendeklarationen
	int cursor_pos=1;
	int i;
	char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen ";
	char text2[]="      Tel. 07462/7381               Fax 07462/7554        ";

	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	_setcursortype(_NOCURSOR);
	textattr(0x7F);
	box(11,2,70,5);
	gotoxy(12,3);
	textattr(0x70);
	cprintf(text1);
	gotoxy(12,4);
	cprintf(text2);
	// Hauptmen erstellen
	haupt_menue();
	// Tastenbettigung einholen
	key=0;
	do
	{
		i=kbhit();
		if (i!=0)
		{
			key=getch();
			if (key==0)
				key=getch();
			switch (key)
			{
				// Taste F1 bettigt
				case 59:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=3;
						// Menpunkt fr Kanal 1 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F2 bettigt
				case 60:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=4;
						// Menpunkt fr Kanal 2 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F3 bettigt
				case 61:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=5;
						// Menpunkt fr Kanal 3 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F4 bettigt
				case 62:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=6;
						// Menpunkt fr Kanal 4 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F5 bettigt
				case 63:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=7;
						// Menpunkt fr Kanal 5 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F6 bettigt
				case 64:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=8;
						// Menpunkt fr Kanal 6 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F7 bettigt
				case 65:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=9;
						// Menpunkt fr Kanal 7 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F8 bettigt
				case 66:{
						// Hauptmen ohne hervorgehobene Cursorposition ausgeben
						puttext(24,8,57,22,screen_buffer);
						// Cursorposition im Hauptmen setzen
						cursor_pos=10;
						// Menpunkt fr Kanal 8 hervorheben
						haupt_menue_bar(cursor_pos);
						// Konfigurationsmen ausgeben und neue Konfiguration
						// im Feld konfig speichern
						konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
						break;}
				// Taste F9 bettigt
				case 67:{
						// Funktion fr Ausgabemen aufrufen
						ausgabe_menue();
						// Cursorposition im Hauptmen setzen
						cursor_pos=2;
						// Menpunkt fr Ausgabemen hervorheben
						haupt_menue_bar(cursor_pos);
						break;}
				// Taste F10 bettigt
				case 68:{
						// Funktion fr digitale Eingnge
						digitale_Eingaenge();
						// Cursorposition im Hauptmen setzen
						cursor_pos=1;
						// Menpunkt fr digitale Eingnge hervorheben
						haupt_menue_bar(cursor_pos);
						break;}
				// Taste Cursor ab bettigt
				case 80:{
						if(cursor_pos==11)
							cursor_pos=1;
						else
							cursor_pos++;
						// neue Cursorposition hervorheben
						haupt_menue_bar(cursor_pos);
						break;}
				// Taste Cursor auf bettigt
				case 72:{
						if(cursor_pos==1)
							cursor_pos=11;
						else
							cursor_pos--;
						// neue Cursorposition hervorheben
						haupt_menue_bar(cursor_pos);
						break;}
				// Taste Return bettigt
				case 13:{
						switch(cursor_pos)
						{
							// aktueller Menpunkt = digitale Eingnge
							case 1:{
									// Funktion fr digitale Eingne aufrufen
									digitale_Eingaenge();
									// Cursorposition im Hauptmen setzen
									cursor_pos=1;
									// neue Cursorposition hervorheben
									haupt_menue_bar(cursor_pos);
									break;}
							// aktueller Menpunkt = Ausgabemen
							case 2:{
									// Funktion fr Ausgabemen aufrufen
									ausgabe_menue();
									// Cursorposition im Hauptmen setzen
									cursor_pos=1;
									// neue Cursorposition hervorheben
									haupt_menue_bar(cursor_pos);
									break;}
							// aktueller Menpunkt ESC = Ende
							case 11:{
									key=27;
									break;}
							// aktueller Menpunkt = Kanal 1-8
							default:{
									konfig[cursor_pos-3]=konfig_menue(cursor_pos-1);
									break;}
						}
						break;}
			}
		}
	// Abbruchbedingung = ESC-Taste
	}while (key!=27);
	// Ausgangskanle auf Minimum des Bereiches setzen
	for(i=0;i<=7;i++)
	{
		write_board(0x00,i);
	}
	// Bildschirm lschen
	textattr(0x07);
	clrscr();
	_setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
}

/****************************************************************************
 ***                    Funktionen fr DA 1256                            ***
 ****************************************************************************/

void write_board(int current, int channel)
{
	// Abfrage des Statusbit, ob vorherige DA-Wandlung noch aktiv ist
	do
	{
	}while((inportb(address) & 0x08)==0);
	// neue Messwertausgabe starten
	outportb(address,(current & 0xFF));						// untere 8 Bit
	outportb(address+1,((current >> 8) + (channel << 4)));	// untere 4 Bit
}

// Funktion fr digitale Eingnge
void digitale_Eingaenge(void)
{
	int input=0;
	int eingaenge[4]={0,0,0,0};

	// Bildschirmbereich lschen
	window(1,8,80,25);
	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	window(1,1,80,25);
	// Fenster fr digitale Eingnge ausgeben
	box(28,10,53,20);
	// Fenster mit digitale Eingnge 1-4 beschriften
	textattr(0x70);
	gotoxy(29,11);
	cprintf(" digitaler Eingang 1: ");
	gotoxy(29,13);
	cprintf(" digitaler Eingang 2: ");
	gotoxy(29,15);
	cprintf(" digitaler Eingang 3: ");
	gotoxy(29,17);
	cprintf(" digitaler Eingang 4: ");
	textattr(0x17);
	gotoxy(29,19);
	cprintf("                        ");
	textattr(0x13);
	gotoxy(36,19);
	cprintf("ESC = Ende");
	textattr(0x70);
	// Einlesen der digitalen Eingnge
	do
	{
		input=inportb(address);
		input=input >> 4;
		eingaenge[0]=(input & 0x01);		// digitaler Eingang 1
		input=input >> 1;
		eingaenge[1]=(input & 0x01);		// digitaler Eingang 2
		input=input >> 1;
		eingaenge[2]=(input & 0x01);		// digitaler Eingang 3
		input=input >> 1;
		eingaenge[3]=(input & 0x01);		// digitaler Eingang 4
		for(i=0;i<=3;i++)
		{
			gotoxy(51,11+(i*2));
			cprintf("%1d", eingaenge[i]);
		}
		if (kbhit())
			key=getch();
	// Abbruchbedingung = ESC-Taste
	}while(key != 27);
	key=0;
}

/*****************************************************************************
 ***                  Funktionen fr Mendarstellungen                     ***
 ****************************************************************************/

// Funktion zur Erstellung des Hauptmens
void haupt_menue(void)
{
	// Fenster fr Hauptmen ausgeben
	box1(24,8,55,23);
	// Menpunkte fr Kanle konfigurieren schreiben
	textattr(0x70);
	for(i=0;i<=7;i++)
	{
		gotoxy(26,13+i);
		cprintf(" F%1d = Kanal %1d konfigurieren ", i+1,i+1);
	}
	// Abgrenzung fr Menpunkt Ausgabemen ausgeben
	for(i=26;i<=53;i++)
	{
		gotoxy(i,12);
		cprintf("");
	}
	gotoxy(25,12);
	cprintf("");
	gotoxy(54,12);
	cprintf("");
	// Menpunkt Ausgabemen ausgeben
	gotoxy(26,11);
	cprintf(" F9 = Ausgabemen           ");
	// Abgrenzung fr Menpunkt digitale Eingnge
	for(i=26;i<=53;i++)
	{
		gotoxy(i,10);
		cprintf("");
	}
	gotoxy(25,10);
	cprintf("");
	gotoxy(54,10);
	cprintf("");
	// Menpunkt digitale Eingnge ausgeben
	gotoxy(26,9);
	cprintf(" F10= digitale Eingnge     ");
	// Abgrenzung fr Menpunkt ESC = Ende ausgeben
	for(i=26;i<=53;i++)
	{
		gotoxy(i,21);
		cprintf("");
	}
	gotoxy(25,21);
	cprintf("");
	gotoxy(54,21);
	cprintf("");
	// Menpunkt ESC = Ende ausgeben
	gotoxy(26,22);
	cprintf(" ESC = Ende                 ");
	// Hauptmen ohne hervorgehobene Cursorposition sichern
	gettext(24,8,57,24,screen_buffer);
	// Cursorposition fr Menpunkt Ausgabemen hervorheben
	textattr(0x20);
	gotoxy(26,9);
	cprintf(" F10= digitale Eingnge     ");
}

// Funktion zur Hervorhebung der Cursorposition im Hauptmen
void haupt_menue_bar(int cursor_pos)
{
	// Bildschirm ohne hervorgehobene Cursorzeile holen
	puttext(24,8,57,24,screen_buffer);
	textattr(0x20);
	for(i=0;i<=7;i++)
	{
		// Cursorposition hervorheben fr Kanle konfigurieren
		if((i+3)==cursor_pos)
		{
			gotoxy(26,13+i);
			cprintf(" F%1d = Kanal %1d konfigurieren ", i+1,i+1);
		}
		// Cursorposition hervorheben fr ESC = Ende
		if(cursor_pos==11)
		{
			gotoxy(26,22);
			cprintf(" ESC = Ende                 ");
		}
		// Cursorposition hervorheben fr Ausgabemen
		if(cursor_pos==2)
		{
			gotoxy(26,11);
			cprintf(" F9 = Ausgabemen           ");
		}
		// Cursorposition hervorheben fr digitale Eingnge
		if(cursor_pos==1)
		{
			gotoxy(26,9);
			cprintf(" F10= digitale Eingnge     ");
		}
	}
}

// Funktion zur Eingabe neuer Werte fr DA 1326
void ausgabe_menue(void)
{
	int cursor_pos=1;

	// Bildschirmbereich lschen
	window(1,8,80,25);
	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	window(1,1,80,25);
	// Fendter fr Konfigurationsdaten der Kanle ausgeben
	box(12,11,30,20);
	// Fenster fr Menpunkte der Kanle ausgeben
	box1(33,10,61,21);
	textattr(0x70);
	// Abgrenzung fr Menpunkt ESC = Ende ausgeben
	for(i=35;i<=59;i++)
	{
		gotoxy(i,19);
		cprintf("");
	}
	gotoxy(34,19);
	cprintf("");
	gotoxy(60,19);
	cprintf("");
	// Konfiguration der Kanle ausgeben
	for(i=0;i<=7;i++)
	{
		switch(konfig[i])
		{
			case 1:{
					gotoxy(13,12+1*i);
					cprintf(" Kanal %1d: 0-2,5 V", i+1);
					break;}
			case 2:{
					gotoxy(13,12+1*i);
					cprintf(" Kanal %1d: 0-5   V", i+1);
					break;}
			case 3:{
					gotoxy(13,12+1*i);
					cprintf(" Kanal %1d: 0-10  V", i+1);
					break;}
			case 4:{
					gotoxy(13,12+1*i);
					cprintf(" Kanal %1d:  2,5 V", i+1);
					break;}
			case 5:{
					gotoxy(13,12+1*i);
					cprintf(" Kanal %1d:  5   V", i+1);
					break;}
			case 6:{
					gotoxy(13,12+1*i);
					cprintf(" Kanal %1d:  10  V", i+1);
					break;}
			case 7:{
					gotoxy(13,12+1*i);
					cprintf(" Kanal %1d: 0-20 mA", i+1);
					break;}
		}
	}
	// Einheit des Ausgabebereiches schreiben
	for(i=0;i<=7;i++)
	{
		gotoxy(35,11+i);
		cprintf(" F%1d = Kanal %1d:%7.3f ", i+1,i+1,ausgabe_wert[i]);
		gotoxy(57,11+i);
		if(konfig[i]==7)
			cprintf("mA ");
		else
			cprintf(" V ");
	}
	// Menpunkt ESC = Ende schreiben
	gotoxy(35,20);
	cprintf(" ESC = Ende    ");
	// Ausgabemen ohne hervorgehobene Cursorposition sichern
	gettext(33,10,63,23,screen_buffer1);
	// Menpunkt fr Kanal 1 hervorheben
	textattr(0x20);
	gotoxy(35,11);
	cprintf(" F1 = Kanal 1:%7.3f ", ausgabe_wert[0]);
	gotoxy(57,11);
	if(konfig[0]==7)
		cprintf("mA ");
	else
		cprintf(" V");
	key=0;
	// Schleife fr Tastatureingaben
	do
	{
		i=kbhit();
		if (i!=0)
		{
			key=getch();
			if (key==0)
				key=getch();
			switch (key)
			{
				// Taste F1 bettigt
				case 59:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=1;
						// Menpunkt fr Kanal 1 hervorheben
						ausgabe_menue_bar(cursor_pos);
						// neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste F2 bettigt
				case 60:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=2;
						// Menpunkt fr Kanl 2 hervorheben
						ausgabe_menue_bar(cursor_pos);
						// neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste F3 bettigt
				case 61:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=3;
						// Menpunkt fr Kanal 3 hervorheben
						ausgabe_menue_bar(cursor_pos);
						// neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste F4 bettigt
				case 62:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=4;
						// Menpunkt fr Kanal 4 hervorheben
						ausgabe_menue_bar(cursor_pos);
						// neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste F5 bettigt
				case 63:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=5;
						// Menpunkt fr Kanal 5 hervorheben
						ausgabe_menue_bar(cursor_pos);
						// neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste F6 bettigt
				case 64:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=6;
						// Menpunkt fr Kanal 6 hervorheben
						ausgabe_menue_bar(cursor_pos);
						// neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste F7 bettigt
				case 65:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=7;
						// Menpunkt fr Kanl 7 hervorheben
						ausgabe_menue_bar(cursor_pos);
						//neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste F8 bettigt
				case 66:{
						// Cursorposition im Ausgabemen setzen
						cursor_pos=8;
						// Menpunkt fr Kanal 8 hervorheben
						ausgabe_menue_bar(cursor_pos);
						// neuer Wert einholen und im Feld ausgabe_wert speichern
						ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
						// neuer Wert in Ausgabemen schreiben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste Cursor ab bettigt
				case 80:{
						if(cursor_pos==9)
							cursor_pos=1;
						else
							cursor_pos++;
						// neue Cursorposition hervorheben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste Cursor auf bettigt
				case 72:{
						if(cursor_pos==1)
							cursor_pos=9;
						else
							cursor_pos--;
						// neue Cursorposition hervorheben
						ausgabe_menue_bar(cursor_pos);
						break;}
				// Taste Return bettigt
				case 13:{
						// Menpunkt ESC = Ende hervorgehoben
						if(cursor_pos==9)
							key=27;
						else
						{
							// neuer Wert einholen und im Feld ausgabe_wert speichern
							ausgabe_wert[cursor_pos-1]=edit_fenster(cursor_pos);
							// neuer Wert in Ausgabemen schreiben
							ausgabe_menue_bar(cursor_pos);
						}
						break;}
			}
		}
	// Abbruchbedingung Taste ESC
	}while (key!=27);
	// Bildschirmbereich lschen
	window(1,8,80,25);
	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	window(1,1,80,25);
	key=0;
}

// Funktion zur Hervorhebung der Cursorposition im Ausgabemen
void ausgabe_menue_bar(int cursor_pos)
{
	// Ausgabemen ohne hervorgehobene Cursorposition holen
	puttext(33,10,63,23,screen_buffer1);
	textattr(0x70);
	// aktuelle Werte der Kanle auf Bildschirm schreiben
	for(i=0;i<=7;i++)
	{
		gotoxy(49,11+i);
		cprintf("%7.3f", ausgabe_wert[i]);
	}
	textattr(0x20);
	// Cursorposition fr Kanle hervorheben
	for(i=0;i<=7;i++)
	{
		if((i+1)==cursor_pos)
		{
			gotoxy(35,11+i);
			cprintf(" F%1d = Kanal %1d:%7.3f ", i+1,i+1,ausgabe_wert[i]);
			gotoxy(57,11+i);
			if(konfig[i]==7)
				cprintf("mA ");
			else
				cprintf(" V ");
		}
		// Cursorposition fr ESC = Ende hervorheben
		if(cursor_pos==9)
		{
			gotoxy(35,20);
			cprintf(" ESC = Ende              ");
		}
	}
}

// Funktion fr Konfigurationsmen und Auswahl neuer Konfiguration der Aus-
// gangskanle
int konfig_menue(int Kanal)
{
	char text1[]=" 0 - 2,5 Volt";
	char text2[]=" 0 - 5   Volt";
	char text3[]=" 0 - 10  Volt";
	char text4[]="    2,5 Volt";
	char text5[]="    5   Volt";
	char text6[]="    10  Volt";
	char text7[]=" 0 - 20  mA  ";
	int cursor_pos;
	int end=0;


	// Cursorposition im Konfigurationsmen setzen
	cursor_pos=konfig[Kanal-2];
	// Fenster fr Konfigurationsmen ausgeben
	box1(58,12,74,20);
	// Menpunkte des Konfigurationsmens ausgeben
	textattr(0x70);
	for(i=1;i<=7;i++)
	{
		gotoxy(60,12+i);
		switch(i)
		{
			case 1:
					cprintf(text1);
					break;
			case 2:
					cprintf(text2);
					break;
			case 3:
					cprintf(text3);
					break;
			case 4:
					cprintf(text4);
					break;
			case 5:
					cprintf(text5);
					break;
			case 6:
					cprintf(text6);
					break;
			case 7:
					cprintf(text7);
					break;
		}
	}
	gettext(58,12,76,21,screen_buffer1);
	// aktuellen Menpunkt hervorheben
	textattr(0x20);
	gotoxy(60,12+konfig[Kanal-2]);
	switch(konfig[Kanal-2])
	{
		case 1:
				cprintf(text1);
				break;
		case 2:
				cprintf(text2);
				break;
		case 3:
				cprintf(text3);
				break;
		case 4:
				cprintf(text4);
				break;
		case 5:
				cprintf(text5);
				break;
		case 6:
				cprintf(text6);
				break;
		case 7:
				cprintf(text7);
				break;
	}
	// Tasaturabfrage
	key=0;
	do
	{
		i=kbhit();
		if (i!=0)
		{
			key=getch();
			if (key==0)
				key=getch();
			switch (key)
			{
				// Taste Cursor ab bettigt
				case 80:{
						if(cursor_pos==7)
						{
							cursor_pos=1;
						}
						else
							cursor_pos++;
						break;}
				// Taste Cursor auf bettigt
				case 72:{
						if(cursor_pos==1)
						{
							cursor_pos=7;
						}
						else
							cursor_pos--;
						break;}
				// Taste Return bettigt
				case 13:
						end=1;
						break;
			}
		// Konfigurationsmen ohne hervorgehobene Cursorposition ausgeben
		puttext(58,12,76,21,screen_buffer1);
		// aktuelle Cursorposition hervorheben
		textattr(0x20);
		gotoxy(60,12+cursor_pos);
		switch(cursor_pos)
		{
			case 1:
					cprintf(text1);
					break;
			case 2:
					cprintf(text2);
					break;
			case 3:
					cprintf(text3);
					break;
			case 4:
					cprintf(text4);
					break;
			case 5:
					cprintf(text5);
					break;
			case 6:
					cprintf(text6);
					break;
			case 7:
					cprintf(text7);
					break;
		}
		}
	// Abbruchbedingung end =1
	}while (end!=1);
	// Konfigurationsmen lschen
	window(58,12,76,21);
	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	window(1,1,80,25);
	// Cursorposition zurckgeben
	return(cursor_pos);

}

// Funktion zur Eingabe eines neuen Wertes und Ausgabe auf DA 1326
float edit_fenster(int cursor_pos)
{
	float wert;
	int error=0;
	char key_input[11];
	char *p;

	// Edit-Fenster erstellen
	box(64,11+cursor_pos-2,78,11+cursor_pos);
	do
	{
		// Fehlerflag zurcksetzen
		error=0;
		// Textausgabe fr Edit-Fenster
		textattr(0x70);
		gotoxy(65,11+cursor_pos-1);
		cprintf("Wert: ");
		gotoxy(71,11+cursor_pos-1);
		// Cursor fr Eingabe einschalten
		_setcursortype(_NORMALCURSOR);
		// maximal 8 Zeichen eingeben (mit CR+LF)
		key_input[0]=8;
		// eingabe einholen
		p=cgets(key_input);
		// Cursor abschalten
		_setcursortype(_NOCURSOR);
		// Fehlererkennung fr nur Return-Eingabe
		if(key_input[1]=='\0')
			error=1;
		// Fehlererkennung fr falsche Zeichen
		if(error!=1)
		{
			for(i=1;i<=key_input[1];i++)
			{
				switch(key_input[i+1])
				{
					// Zeichen, die erlaubt sind
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
					case '.':
					case ',':
					case '-':
							break;
					default:
							error=1;
							break;
				}
			}
		}
		// Umwandlung von , in .
		for (i=0;i<=key_input[1];i++)
		{
			if (key_input[i+2]==',')
				key_input[i+2]='.';
		}
		// Eingabewert umwandeln in float
		wert=atof(p);
		if(error==0)
		{
			switch(konfig[cursor_pos-1])
			{
				case 1:{
						// Berechnung fr Bereich 0 - 2,5 Volt
						if((wert<0) || (wert>2.5))
							error=1;
						else
							i=abs(wert*4095/2.5);
						break;}
				case 2:{
						// Berechnung fr Bereich 0 - 5 Volt
						if((wert<0) || (wert>5))
							error=1;
						else
							i=abs(wert*4095/5);
						break;}
				case 3:{
						// Berechnung fr Bereich 0 - 10 Volt
						if((wert<0) || (wert>10))
							error=1;
						else
							i=abs(wert*4095/10);
						break;}
				case 4:{
						// Berechnung fr Bereich  2,5 Volt
						if((wert<-2.5) || (wert>2.5))
							error=1;
						else
							i=abs((wert+2.5)*4095/5);
						break;}
				case 5:{
						// Berechnung fr Bereich  5 Volt
						if((wert<-5) || (wert>5))
							error=1;
						else
							i=abs((wert+5)*4095/10);
						break;}
				case 6:{
						// Berechnung fr Bereich  10 Volt
						if((wert<-10) || (wert>10))
							error=1;
						else
							i=abs((wert+10)*4095/20);
						break;}
				case 7:{
						// Berechnung fr Bereich 0 - 20 mA
						if((wert<0) || (wert>20))
							error=1;
						else
							i=abs(wert*4095/20);
						break;}
			}
		}
		// Ausgabe der Fehlermeldung im Edit-Fenster
		if(error==1)
		{
			gotoxy(65,11+cursor_pos-1);
			cprintf("falscher Wert");
			delay(500);
			gotoxy(65,11+cursor_pos-1);
			cprintf("             ");
		}
	// Eingabe wiederholen bis Fehlerflag = 0
	}while(error==1);
	// Ausgabe des Wertes auf DA 1326
	write_board(i, cursor_pos-1);
	// Edit-Fenster lschen
	window(64,10,80,25);
	textbackground(BLUE);
	textcolor(WHITE);
	clrscr();
	window(1,1,80,25);
	// aktuellen Wert zurckgeben
	return(wert);
}

void box(int x1, int y1, int x2, int y2)
{
  int i,
	  n;

  textattr(0x7F);
  gotoxy(x1,y1);
  cprintf("");
  gotoxy(x2,y1);
  cprintf("");
  gotoxy(x1,y2);
  cprintf("");
  gotoxy(x2,y2);
  cprintf("");
  for (i=x1+1;i<=x2-1;i++)
  {
	gotoxy(i,y1);
	cprintf("");
	gotoxy(i,y2);
	cprintf("");
  }
  for (i=y1+1;i<=y2-1;i++)
  {
	gotoxy(x1,i);
	cprintf("");
	gotoxy(x2,i);
	cprintf("");
  }
  for (i=y1+1;i<=y2-1;i++)
  {
	for (n=x1+1;n<=x2-1;n++)
	{
	  gotoxy(n,i);
	  cprintf(" ");
	}
  }
  textattr(0x10);
  for (i=x1+2;i<=x2+1;i++)
  {
	gotoxy(i,y2+1);
	cprintf("");
  }
  for (i=y1+1;i<=y2+1;i++)
  {
	gotoxy(x2+1,i);
	cprintf("");
  }
}

void box1(int x1, int y1, int x2, int y2)
{
  int i,
	  n;

  textattr(0x70);
  for(i=y1;i<=y2;i++)
  {
	for(n=x1;n<=x2;n++)
	{
		gotoxy(n,i);
		cprintf(" ");
	}
  }
  gotoxy(x1+1,y1);
  cprintf("");
  gotoxy(x2-1,y1);
  cprintf("");
  gotoxy(x1+1,y2);
  cprintf("");
  gotoxy(x2-1,y2);
  cprintf("");
  for (i=x1+2;i<=x2-2;i++)
  {
	gotoxy(i,y1);
	cprintf("");
	gotoxy(i,y2);
	cprintf("");
  }
  for (i=y1+1;i<=y2-1;i++)
  {
	gotoxy(x1+1,i);
	cprintf("");
	gotoxy(x2-1,i);
	cprintf("");
  }
  textattr(0x10);
  for (i=x1+2;i<=x2+1;i++)
  {
	gotoxy(i,y2+1);
	cprintf("");
  }
  for (i=y1+1;i<=y2+1;i++)
  {
	gotoxy(x2+1,i);
	cprintf("");
  }
}