(****************************************************************************
 ***             Beispielprogramm fr PC-Steckkarte DA 1326               ***
 ****************************************************************************
 *** Programmname      : 1326PAS.PAS                                      ***
 *** Programmiersprache: Turbo Pascal Version 7.0                         ***
 ***                                                                      ***
 *** erstellt von       Datum                                             ***
 *** Ralf Mller        24.06.97                                          ***
 ****************************************************************************
 *** ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen             ***
 *** Tel.: 07462/7381                                                     ***
 *** Fax : 07462/7554                                                     ***
 ****************************************************************************)
program p1326pas;
uses
 	crt, dos;
const
	address=$100;							(* Basisadresse der DA 1326 *)
type
    int_array1=array [1..4] of integer;
(* globale Variablendeklarationen *)
var
    key			: byte;
    i			: integer;

(* Funktions- und Prozedurdefinitionen *)

(* Prozedur um einen Rahmen zu zeichnen *)
procedure box(x1,y1,x2,y2:integer);
var
	i,
 	n   : integer;
begin
 	textattr:= white + 7 * 16;
 	gotoxy(x1,y1);
 	write('');
 	gotoxy(x2,y1);
 	write('');
 	gotoxy(x1,y2);
 	write('');
 	gotoxy(X2,Y2);
 	write('');
 	for i:= (x1+1) to (x2-1) do begin
   		gotoxy(i,y1);
   		write('');
   		gotoxy(i,y2);
   		write('');
 	end;
 	for i:=(y1+1) to (y2-1) do begin
   		gotoxy(x1,i);
   		write('');
   		gotoxy(x2,i);
   		write('');
  	end;
 	for i:=(y1+1) to (y2-1) do begin
   		for n:=(x1+1) to (x2-1) do begin
     		gotoxy(n,i);
     		write(' ');
    	end;
  	end;
 	textattr:=black + blue * 16;
 	for i:=(x1+2) to (x2+1) do begin
   		gotoxy(i,y2+1);
   		write('');
  	end;
 	for i:=(y1+1) to (y2+1) do begin
   		gotoxy(x2+1,i);
   		write('');
  	end;
end;

(* Prozedur um Cursor an- und abzuschalten *)
procedure cursor(sichtbar: boolean);
VAR
 	reg : registers;
	schirmanfang : longint;
BEGIN
 	reg.ah:=1;
 	if sichtbar then begin
    	if schirmanfang=$b800 then begin
       		reg.ch:=6;
       		reg.cl:=7;
      	end
     	else begin
       		reg.ch:=12;
       		reg.cl:=13;
      	end;
    	intr(16,reg);
	end
  	else begin
    	reg.ch:=32;
    	reg.cl:=7;
    	intr(16,reg);
   	end;
end;

(* Prozedur um Wert auf DA 1326 auszugeben *)
procedure write_board(wert, Kanal:integer);
begin
    (* Abfrage des Statusbits, ob vorherige DA-Wandlung noch aktiv ist *)
    repeat
    until((port[address] AND $08)<>0);
    (* neue Ausgabe starten *)
	port[address]:=(wert AND $FF);						(* obere 8 Bit *)
    port[address+1]:=((wert shr 8) + (Kanal shl 4));	(* untere 4 Bit *)
end;

(* Prozedur zum Einlesen eines Wertes und Ausgabe an die DA 1326 *)
procedure out_wert(Kanal:integer);
var
	error		: integer;
    i			: integer;
    wert		: integer;
    code		: integer;
    key_input	: string[4];
begin
	(* Edit-Fenster ausgeben*)
    box(56,12+Kanal-2,71,12+Kanal+1);
    textattr:=$70;
    gotoxy(59,12+Kanal-1);
    write('von 0-4095');
    repeat
        (* Fehlerflag zurcksetzen *)
    	error:=0;
		gotoxy(57,12+Kanal);
        write('Wert: ');
        (* Eingabefenster setzen *)
		window(63,12+Kanal,67,12+Kanal);
        (* Cursor fr Eingabe ausschalten *)
        cursor(true);
        (* Eingabe einholen *)
    	readln(key_input);
        (* Cursor abschalten *)
        cursor(false);
        (* string in integer umwandeln *)
        val(key_input,wert,code);
        (* Eingabe auf Falschzeichen abfragen *)
        if(code<>0) then
        	error:=1;
        if(error=0) then
			if((wert<0) OR (wert>4095)) then
				error:=1;
        (* Ausgabe der Fehlermeldung im Edit-Fenster *)
        if(error=1) then begin
        	window(1,1,80,25);
            gotoxy(57,12+Kanal);
            write('falscher Wert');
            delay(500);
            gotoxy(57,12+Kanal);
            write('             ');
        end;
    (* Eingabe wiederholen bis Fehlerflag = 0 *)
	until (error=0);
    write_board(wert,Kanal);
    window(1,1,80,25);
	gotoxy(46,12+Kanal);
    write(wert:4);
    (* Edit-Fenster lschen *)
    window(56,10,80,25);
    textbackground(blue);
    textcolor(white);
    clrscr;
    window(1,1,80,25);
end;

procedure in_eingaenge;
VAR
	input		: integer;
    i			: integer;
    eingaenge	: int_array1;
begin
	input:=port[address];
    eingaenge[1]:=((input shr 4) AND $01);
	eingaenge[2]:=((input shr 5) AND $01);
    eingaenge[3]:=((input shr 6) AND $01);
    eingaenge[4]:=((input shr 7) AND $01);
    textattr:=$70;
    for i:=1 to 4 do begin
    	gotoxy(24,10+((i-1)*4));
        write(eingaenge[i]);
    end;
end;

(* Hauptprogramm *)
begin
	textbackground(blue);
    textcolor(white);
    clrscr;
    cursor(false);
    textattr:=$7F;
    box(11,2,70,5);
    textattr:=$70;
    gotoxy(12,3);
    write(' ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen ');
	gotoxy(12,4);
    write('      Tel. 07462/7381               Fax 07462/7554        ');
    (* Fenster fr digitale Eingnge *)
    box(11,9,26,11);
    box(11,13,26,15);
    box(11,17,26,19);
    box(11,21,26,23);
    (* Fenster fr Ausgnge 1-8 *)
    box(30,11,52,21);
    textattr:=$17;
    gotoxy(31,20);
    write('                     ');
	textattr:=$13;
	gotoxy(36,20);
	write('ESC = Ende');
    (* Text fr Fenster der digitalen Eingnge ausgeben *)
	textattr:=$70;
    for i:=0 to 3 do begin
    	gotoxy(12,10+i*4);
        write(' Eingang ',i+1,': 1');
    end;
    (* Text fr Fenster der Ausgnge 1-8 ausgeben *)
    for i:=0 to 7 do begin
    	gotoxy(31,12+i);
        write(' F',i+1,' = Kanal ',i+1,' ');
        gotoxy(46,12+i);
        write(0:4);
    end;
    repeat
        if keypressed then begin
		key:=ord(readkey);
        case key of
            (* Taste F1 bettigt *)
        	59:
				begin
                (* neuer Wert einholen und auf Kanal 1 ausgeben *)
                out_wert(0);
                end;
            (* Taste F2 bettigt *)
            60:
            	begin
                (* neuer Wert einholen und auf Kanl 2 ausgeben *)
                out_wert(1);
                end;
            (* Taste F3 bettigt *)
            61:
            	begin
                (* neuer Wert einholen und auf Kanal 3 ausgeben *)
                out_wert(2);
                end;
            (* Taste F4 bettigen *)
            62:
            	begin
                (* neuer Wert einholen und auf Kanal 4 ausgeben *)
                out_wert(3);
                end;
            (* Taste F5 bettigen *)
            63:
            	begin
                (* neuer Wert einholen und auf Kanal 5 ausgeben *)
                out_wert(4);
                end;
            (* Taste F6 bettigt *)
            64:
            	begin
                (* neuer Wert einholen und auf Kanal 6 ausgeben *)
                out_wert(5);
                end;
            (* Taste F7 bettigt *)
            65:
            	begin
                (* neuer Wert einholen und auf Kanal 7 ausgeben *)
                out_wert(6);
                end;
            (* Taste F8 bettigt *)
            66:
            	begin
                (* neuer Wert einholen und auf Kanal 8 ausgeben *)
                out_wert(7);
                end;
        end;
        end;
        (* einlesen der digitalen Eingnge und Ausgabe *)
        in_eingaenge;
    until (key=27);
  (* Ausgangskanle auf Minimum des Bereiches setzen *)
  for i:=0 to 7 do
  	write_board($00,i);
  textbackground(black);
  textcolor($7);
  clrscr;
  cursor(true); (*Cursor anschalten*)
end.